// jitops.c
// RA-TOD this will be rewritten for speed in due course

case JIT_endop:     goto donefor;

case JIT_push_r:
    incStack(p);
    TOS = op->operand;
    Dassert(TYPEOF(TOS) == REALSXP);
    break;

case JIT_push_i:
    incStack(p);
    TOS = op->operand;
    Dassert(TYPEOF(TOS) == INTSXP || TYPEOF(TOS) == LGLSXP);
    break;

case JIT_Cpush_r:
    incStackWithCheck(p);
    TOS = op->operand;
    Dassert(TYPEOF(TOS) == REALSXP);
    break;

case JIT_Cpush_i:
    incStackWithCheck(p);
    TOS = op->operand;
    Dassert(TYPEOF(TOS) == INTSXP || TYPEOF(TOS) == LGLSXP);
    break;

case JIT_pushsym_r:
    pushSym(op, p->ans, REALSXP, p);
    break;

case JIT_pushsym_i:
    pushSym(op, p->ans, INTSXP, p);
    break;

case JIT_Cpushsym_r:
    pushSymWithCheck(op, p->ans, REALSXP, p);
    break;

case JIT_Cpushsym_i:
    pushSymWithCheck(op, p->ans, INTSXP, p);
    break;

case JIT_math1_r:
    result = op->result; DCheckMath1(result, REALSXP);
    ar = REAL(result); yr = YR; func1 = op->func; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = func1(yr[i]);
    stack[istack] = result;
    break;

case JIT_math1_r1:
    result = op->result; DCheckMath1_1(result, REALSXP);
    ar = REAL(result); yr = YR; func1 = op->func;
    ar[0] = func1(yr[0]);
    stack[istack] = result;
    break;

case JIT_math1_i:
    result = op->result; DCheckMath1(result, INTSXP);
    ar = REAL(result); yi = YI; func1 = op->func; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = func1((double)yi[i]);
    stack[istack] = result;
    break;

case JIT_math1_i1:
    result = op->result; DCheckMath1_1(result, INTSXP);
    ar = REAL(result); yi = YI; func1 = op->func;
    ar[0] = func1((double)yi[0]);
    stack[istack] = result;
    break;

// x[subset]: X is x, Y is subset

      // print a JIT_OPcase JIT_subset_r_i1:
    result = op->result; DCheckSubscript_x_y1(REALSXP, INTSXP, result);
    yi0 = YI[0] - 1;
    xr0 = XR[yi0];  X = result; *REAL(stack[--istack]) = xr0;
    break;

case JIT_subset_r_r1:
    result = op->result; DCheckSubscript_x_y1(REALSXP, REALSXP, result);
    yr0 = YR[0] - 1;
    xr0 = XR[(int)yr0]; X = result; *REAL(stack[--istack]) = xr0;
    break;

case JIT_subset_i_i1:
    result = op->result; DCheckSubscript_x_y1(INTSXP, INTSXP, result);
    yi0 = YI[0] - 1;
    xi0 = XI[yi0];  X = result; *INTEGER(stack[--istack]) = xi0;
    break;

case JIT_subset_i_r1:
    result = op->result; DCheckSubscript_x_y1(INTSXP, REALSXP, result);
    yr0 = YR[0] - 1;
    xi0 = XI[(int)yr0]; X = result; *INTEGER(stack[--istack]) = xi0;
    break;

// as above but with subscript range check
case JIT_Csubset_r_i1:
    result = op->result; DCheckSubscript_x_y1(REALSXP, INTSXP, result);
    yi0 = YI[0] - 1; CheckSubscript_i(X, yi0, p);
    xr0 = XR[yi0];  X = result; *REAL(stack[--istack]) = xr0;
    break;

case JIT_Csubset_r_r1:
    result = op->result; DCheckSubscript_x_y1(REALSXP, REALSXP, result);
    yr0 = YR[0] - 1; CheckSubscript_r(X, yr0, p);
    xr0 = XR[(int)yr0]; X = result; *REAL(stack[--istack]) = xr0;
    break;

case JIT_Csubset_i_i1:
    result = op->result; DCheckSubscript_x_y1(INTSXP, INTSXP, result);
    yi0 = YI[0] - 1; CheckSubscript_i(X, yi0, p);
    xi0 = XI[yi0];  X = result; *INTEGER(stack[--istack]) = xi0;
    break;

case JIT_Csubset_i_r1:
    result = op->result; DCheckSubscript_x_y1(INTSXP, REALSXP, result);
    yr0 = YR[0] - 1; CheckSubscript_r(X, yr0, p);
    xi0 = XI[(int)yr0]; X = result; *INTEGER(stack[--istack]) = xi0;
    break;

// Assign TOS to op->operand (which is a binding location) and leave TOS as is.
// RA_TODO fix NAMED for assigns
// RA_TODO all these assigns will be conflated, but then will lose Dchecks

case JIT_assign_r1_r1:
    DCheckAssign(op, REALSXP, REALSXP, 1);
    R_set_binding_value(op->operand, TOS);
    break;

case JIT_assign_r1_i1:
    Dassert(0);
    DCheckAssign(op, REALSXP, INTSXP, 1);
    R_set_binding_value(op->operand, TOS);
    break;

case JIT_assign_i1_r1:
    Dassert(0);
    DCheckAssign(op, INTSXP, REALSXP, 1);
    R_set_binding_value(op->operand, TOS);
    break;

case JIT_assign_i1_i1:
    DCheckAssign(op, INTSXP, INTSXP, 1);
    R_set_binding_value(op->operand, TOS);
    break;

case JIT_assign_r_r:
    DCheckAssign(op, REALSXP, REALSXP, -1);
    R_set_binding_value(op->operand, TOS);
    break;

case JIT_assign_r_i:
    Dassert(0);
    DCheckAssign(op, REALSXP, INTSXP, -1);
    R_set_binding_value(op->operand, TOS);
    break;

case JIT_assign_i_r:
    Dassert(0);
    DCheckAssign(op, INTSXP, REALSXP, -1);
    R_set_binding_value(op->operand, TOS);
    break;

case JIT_assign_i_i:
    DCheckAssign(op, INTSXP, INTSXP, -1);
    R_set_binding_value(op->operand, TOS);
    break;

case JIT_add_r_r: // x+y, both x and y are on the stack, x at TOS-1, y at TOS
    result = op->result; DCheckBinop_x_y(REALSXP, REALSXP, result);
    ar = REAL(result); xr = XR; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] + yr[i]; stack[--istack] = result;
    break;

case JIT_add_r_r1:
    result = op->result; DCheckBinop_x_y1(REALSXP, REALSXP, result);
    ar = REAL(result); xr = XR; yr0 = YR[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] + yr0;   stack[--istack] = result;
    break;

case JIT_add_r1_r:
    result = op->result; DCheckBinop_x1_y(REALSXP, REALSXP, result);
    ar = REAL(result); xr0 = XR[0]; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr0 + yr[i];   stack[--istack] = result;
    break;

case JIT_add_r1_r1:
    result = op->result; DCheckBinop_x1_y1(REALSXP, REALSXP, result);
    REAL(result)[0] = XR[0] + YR[0];               stack[--istack] = result;
    break;

case JIT_add_r_i:
    result = op->result; DCheckBinop_x_y(REALSXP, INTSXP, result);
    ar = REAL(result); xr = XR; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] + yi[i]; stack[--istack] = result;
    break;

case JIT_add_r_i1:
    result = op->result; DCheckBinop_x_y1(REALSXP, INTSXP, result);
    ar = REAL(result); xr = XR; yi0 = YI[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] + yi0;   stack[--istack] = result;
    break;

case JIT_add_r1_i:
    result = op->result; DCheckBinop_x1_y(REALSXP, INTSXP, result);
    ar = REAL(result); xr0 = XR[0]; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr0 + yi[i];   stack[--istack] = result;
    break;

case JIT_add_r1_i1:
    result = op->result; DCheckBinop_x1_y1(REALSXP, INTSXP, result);
    REAL(result)[0] = XR[0] + YI[0];               stack[--istack] = result;
    break;

case JIT_add_i_r:
    result = op->result; DCheckBinop_x_y(INTSXP, REALSXP, result);
    ar = REAL(result); xi = XI; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi[i] + yr[i]; stack[--istack] = result;
    break;

case JIT_add_i_r1:
    result = op->result; DCheckBinop_x_y1(INTSXP, REALSXP, result);
    ar = REAL(result); xi = XI; yr0 = YR[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi[i] + yr0;   stack[--istack] = result;
    break;

case JIT_add_i1_r:
    result = op->result; DCheckBinop_x1_y(INTSXP, REALSXP, result);
    ar = REAL(result); xi0 = XI[0]; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi0 + yr[i];   stack[--istack] = result;
    break;

case JIT_add_i1_r1:
    result = op->result; DCheckBinop_x1_y1(INTSXP, REALSXP, result);
    REAL(result)[0] = XI[0] + YR[0];               stack[--istack] = result;
    break;

case JIT_add_i_i:
    result = op->result; DCheckBinop_x_y(INTSXP, INTSXP, result);
    ai = INTEGER(result); xi = XI; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ai[i] = xi[i] + yi[i]; stack[--istack] = result;
    break;

case JIT_add_i_i1:
    result = op->result; DCheckBinop_x_y1(INTSXP, INTSXP, result);
    ai = INTEGER(result); xi = XI; yi0 = YI[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ai[i] = xi[i] + yi0;   stack[--istack] = result;
    break;

case JIT_add_i1_i:
    result = op->result; DCheckBinop_x1_y(INTSXP, INTSXP, result);
    ai = INTEGER(result); xi0 = XI[0]; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ai[i] = xi0 + yi[i];   stack[--istack] = result;
    break;

case JIT_add_i1_i1:
    result = op->result; DCheckBinop_x1_y1(INTSXP, INTSXP, result);
    INTEGER(result)[0] = XI[0] + YI[0];            stack[--istack] = result;
    break;

case JIT_sub_r_r:
    result = op->result; DCheckBinop_x_y(REALSXP, REALSXP, result);
    ar = REAL(result); xr = XR; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] - yr[i]; stack[--istack] = result;
    break;

case JIT_sub_r_r1:
    result = op->result; DCheckBinop_x_y1(REALSXP, REALSXP, result);
    ar = REAL(result); xr = XR; yr0 = YR[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] - yr0;   stack[--istack] = result;
    break;

case JIT_sub_r1_r:
    result = op->result; DCheckBinop_x1_y(REALSXP, REALSXP, result);
    ar = REAL(result); xr0 = XR[0]; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr0 - yr[i];   stack[--istack] = result;
    break;

case JIT_sub_r1_r1:
    result = op->result; DCheckBinop_x1_y1(REALSXP, REALSXP, result);
    REAL(result)[0] = XR[0] - YR[0];               stack[--istack] = result;
    break;

case JIT_sub_r_i:
    result = op->result; DCheckBinop_x_y(REALSXP, INTSXP, result);
    ar = REAL(result); xr = XR; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] - yi[i]; stack[--istack] = result;
    break;

case JIT_sub_r_i1:
    result = op->result; DCheckBinop_x_y1(REALSXP, INTSXP, result);
    ar = REAL(result); xr = XR; yi0 = YI[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] - yi0;   stack[--istack] = result;
    break;

case JIT_sub_r1_i:
    result = op->result; DCheckBinop_x1_y(REALSXP, INTSXP, result);
    ar = REAL(result); xr0 = XR[0]; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr0 - yi[i];   stack[--istack] = result;
    break;

case JIT_sub_r1_i1:
    result = op->result; DCheckBinop_x1_y1(REALSXP, INTSXP, result);
    REAL(result)[0] = XR[0] - YI[0];               stack[--istack] = result;
    break;

case JIT_sub_i_r:
    result = op->result; DCheckBinop_x_y(INTSXP, REALSXP, result);
    ar = REAL(result); xi = XI; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi[i] - yr[i]; stack[--istack] = result;
    break;

case JIT_sub_i_r1:
    result = op->result; DCheckBinop_x_y1(INTSXP, REALSXP, result);
    ar = REAL(result); xi = XI; yr0 = YR[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi[i] - yr0;   stack[--istack] = result;
    break;

case JIT_sub_i1_r:
    result = op->result; DCheckBinop_x1_y(INTSXP, REALSXP, result);
    ar = REAL(result); xi0 = XI[0]; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi0 - yr[i];   stack[--istack] = result;
    break;

case JIT_sub_i1_r1:
    result = op->result; DCheckBinop_x1_y1(INTSXP, REALSXP, result);
    REAL(result)[0] = XI[0] - YR[0];               stack[--istack] = result;
    break;

case JIT_sub_i_i:
    result = op->result; DCheckBinop_x_y(INTSXP, INTSXP, result);
    ai = INTEGER(result); xi = XI; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ai[i] = xi[i] - yi[i]; stack[--istack] = result;
    break;

case JIT_sub_i_i1:
    result = op->result; DCheckBinop_x_y1(INTSXP, INTSXP, result);
    ai = INTEGER(result); xi = XI; yi0 = YI[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ai[i] = xi[i] - yi0;   stack[--istack] = result;
    break;

case JIT_sub_i1_i:
    result = op->result; DCheckBinop_x1_y(INTSXP, INTSXP, result);
    ai = INTEGER(result); xi0 = XI[0]; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ai[i] = xi0 - yi[i];   stack[--istack] = result;
    break;

case JIT_sub_i1_i1:
    result = op->result; DCheckBinop_x1_y1(INTSXP, INTSXP, result);
    INTEGER(result)[0] = XI[0] - YI[0];            stack[--istack] = result;
    break;

case JIT_mul_r_r:
    result = op->result; DCheckBinop_x_y(REALSXP, REALSXP, result);
    ar = REAL(result); xr = XR; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] * yr[i]; stack[--istack] = result;
    break;

case JIT_mul_r_r1:
    result = op->result; DCheckBinop_x_y1(REALSXP, REALSXP, result);
    ar = REAL(result); xr = XR; yr0 = YR[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] * yr0;   stack[--istack] = result;
    break;

case JIT_mul_r1_r:
    result = op->result; DCheckBinop_x1_y(REALSXP, REALSXP, result);
    ar = REAL(result); xr0 = XR[0]; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr0 * yr[i];   stack[--istack] = result;
    break;

case JIT_mul_r1_r1:
    result = op->result; DCheckBinop_x1_y1(REALSXP, REALSXP, result);
    REAL(result)[0] = XR[0] * YR[0];               stack[--istack] = result;
    break;

case JIT_mul_r_i:
    result = op->result; DCheckBinop_x_y(REALSXP, INTSXP, result);
    ar = REAL(result); xr = XR; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] * yi[i]; stack[--istack] = result;
    break;

case JIT_mul_r_i1:
    result = op->result; DCheckBinop_x_y1(REALSXP, INTSXP, result);
    ar = REAL(result); xr = XR; yi0 = YI[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] * yi0;   stack[--istack] = result;
    break;

case JIT_mul_r1_i:
    result = op->result; DCheckBinop_x1_y(REALSXP, INTSXP, result);
    ar = REAL(result); xr0 = XR[0]; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr0 * yi[i];   stack[--istack] = result;
    break;

case JIT_mul_r1_i1:
    result = op->result; DCheckBinop_x1_y1(REALSXP, INTSXP, result);
    REAL(result)[0] = XR[0] * YI[0];               stack[--istack] = result;
    break;

case JIT_mul_i_r:
    result = op->result; DCheckBinop_x_y(INTSXP, REALSXP, result);
    ar = REAL(result); xi = XI; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi[i] * yr[i]; stack[--istack] = result;
    break;

case JIT_mul_i_r1:
    result = op->result; DCheckBinop_x_y1(INTSXP, REALSXP, result);
    ar = REAL(result); xi = XI; yr0 = YR[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi[i] * yr0;   stack[--istack] = result;
    break;

case JIT_mul_i1_r:
    result = op->result; DCheckBinop_x1_y(INTSXP, REALSXP, result);
    ar = REAL(result); xi0 = XI[0]; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi0 * yr[i];   stack[--istack] = result;
    break;

case JIT_mul_i1_r1:
    result = op->result; DCheckBinop_x1_y1(INTSXP, REALSXP, result);
    REAL(result)[0] = XI[0] * YR[0];               stack[--istack] = result;
    break;

case JIT_mul_i_i:
    result = op->result; DCheckBinop_x_y(INTSXP, INTSXP, result);
    ai = INTEGER(result); xi = XI; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ai[i] = xi[i] * yi[i]; stack[--istack] = result;
    break;

case JIT_mul_i_i1:
    result = op->result; DCheckBinop_x_y1(INTSXP, INTSXP, result);
    ai = INTEGER(result); xi = XI; yi0 = YI[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ai[i] = xi[i] * yi0;   stack[--istack] = result;
    break;

case JIT_mul_i1_i:
    result = op->result; DCheckBinop_x1_y(INTSXP, INTSXP, result);
    ai = INTEGER(result); xi0 = XI[0]; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ai[i] = xi0 * yi[i];   stack[--istack] = result;
    break;

case JIT_mul_i1_i1:
    result = op->result; DCheckBinop_x1_y1(INTSXP, INTSXP, result);
    INTEGER(result)[0] = XI[0] * YI[0];            stack[--istack] = result;
    break;

case JIT_div_r_r:
    result = op->result; DCheckBinop_x_y(REALSXP, REALSXP, result);
    ar = REAL(result); xr = XR; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] / yr[i]; stack[--istack] = result;
    break;

case JIT_div_r_r1:
    result = op->result; DCheckBinop_x_y1(REALSXP, REALSXP, result);
    ar = REAL(result); xr = XR; yr0 = YR[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] / yr0;   stack[--istack] = result;
    break;

case JIT_div_r1_r:
    result = op->result; DCheckBinop_x1_y(REALSXP, REALSXP, result);
    ar = REAL(result); xr0 = XR[0]; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr0 / yr[i];   stack[--istack] = result;
    break;

case JIT_div_r1_r1:
    result = op->result; DCheckBinop_x1_y1(REALSXP, REALSXP, result);
    REAL(result)[0] = XR[0] / YR[0];               stack[--istack] = result;
    break;

case JIT_div_r_i:
    result = op->result; DCheckBinop_x_y(REALSXP, INTSXP, result);
    ar = REAL(result); xr = XR; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] / yi[i]; stack[--istack] = result;
    break;

case JIT_div_r_i1:
    result = op->result; DCheckBinop_x_y1(REALSXP, INTSXP, result);
    ar = REAL(result); xr = XR; yi0 = YI[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr[i] / yi0;   stack[--istack] = result;
    break;

case JIT_div_r1_i:
    result = op->result; DCheckBinop_x1_y(REALSXP, INTSXP, result);
    ar = REAL(result); xr0 = XR[0]; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xr0 / yi[i];   stack[--istack] = result;
    break;

case JIT_div_r1_i1:
    result = op->result; DCheckBinop_x1_y1(REALSXP, INTSXP, result);
    REAL(result)[0] = XR[0] / YI[0];               stack[--istack] = result;
    break;

case JIT_div_i_r:
    result = op->result; DCheckBinop_x_y(INTSXP, REALSXP, result);
    ar = REAL(result); xi = XI; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi[i] / yr[i]; stack[--istack] = result;
    break;

case JIT_div_i_r1:
    result = op->result; DCheckBinop_x_y1(INTSXP, REALSXP, result);
    ar = REAL(result); xi = XI; yr0 = YR[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi[i] / yr0;   stack[--istack] = result;
    break;

case JIT_div_i1_r:
    result = op->result; DCheckBinop_x1_y(INTSXP, REALSXP, result);
    ar = REAL(result); xi0 = XI[0]; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = xi0 / yr[i];   stack[--istack] = result;
    break;

case JIT_div_i1_r1:
    result = op->result; DCheckBinop_x1_y1(INTSXP, REALSXP, result);
    REAL(result)[0] = XI[0] / YR[0];               stack[--istack] = result;
    break;

// begin unsual code: return REAL even though args are INTs, same as arithmetic.c
case JIT_div_i_i:
    result = op->result; DCheckBinop_x_y(INTSXP, INTSXP, result);
    ar = REAL(result); xi = XI; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = (double)xi[i] / yi[i]; stack[--istack] = result;
    break;

case JIT_div_i_i1:
    result = op->result; DCheckBinop_x_y1(INTSXP, INTSXP, result);
    ar = REAL(result); xi = XI; yi0 = YI[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = (double)xi[i] / yi0;   stack[--istack] = result;
    break;

case JIT_div_i1_i:
    result = op->result; DCheckBinop_x1_y(INTSXP, INTSXP, result);
    ar = REAL(result); xi0 = XI[0]; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = (double)xi0 / yi[i];   stack[--istack] = result;
    break;

case JIT_div_i1_i1:
    result = op->result; DCheckBinop_x1_y1(INTSXP, INTSXP, result);
    REAL(result)[0] = (double)XI[0] / YI[0];               stack[--istack] = result;
    break;
// end unusual code

case JIT_pow_r_r:
    result = op->result; DCheckBinop_x_y(REALSXP, REALSXP, result);
    ar = REAL(result); xr = XR; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xr[i], yr[i]); stack[--istack] = result;
    break;

case JIT_pow_r_r1:
    result = op->result; DCheckBinop_x_y1(REALSXP, REALSXP, result);
    ar = REAL(result); xr = XR; yr0 = YR[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xr[i], yr0);   stack[--istack] = result;
    break;

case JIT_pow_r1_r:
    result = op->result; DCheckBinop_x1_y(REALSXP, REALSXP, result);
    ar = REAL(result); xr0 = XR[0]; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xr0, yr[i]);   stack[--istack] = result;
    break;

case JIT_pow_r1_r1:
    result = op->result; DCheckBinop_x1_y1(REALSXP, REALSXP, result);
    REAL(result)[0] = pow(XR[0], YR[0]);               stack[--istack] = result;
    break;

case JIT_pow_r_i:
    result = op->result; DCheckBinop_x_y(REALSXP, INTSXP, result);
    ar = REAL(result); xr = XR; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xr[i], yi[i]); stack[--istack] = result;
    break;

case JIT_pow_r_i1:
    result = op->result; DCheckBinop_x_y1(REALSXP, INTSXP, result);
    ar = REAL(result); xr = XR; yi0 = YI[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xr[i], yi0);   stack[--istack] = result;
    break;

case JIT_pow_r1_i:
    result = op->result; DCheckBinop_x1_y(REALSXP, INTSXP, result);
    ar = REAL(result); xr0 = XR[0]; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xr0, yi[i]);   stack[--istack] = result;
    break;

case JIT_pow_r1_i1:
    result = op->result; DCheckBinop_x1_y1(REALSXP, INTSXP, result);
    REAL(result)[0] = pow(XR[0], YI[0]);               stack[--istack] = result;
    break;

case JIT_pow_i_r:
    result = op->result; DCheckBinop_x_y(INTSXP, REALSXP, result);
    ar = REAL(result); xi = XI; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xi[i], yr[i]); stack[--istack] = result;
    break;

case JIT_pow_i_r1:
    result = op->result; DCheckBinop_x_y1(INTSXP, REALSXP, result);
    ar = REAL(result); xi = XI; yr0 = YR[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xi[i], yr0);   stack[--istack] = result;
    break;

case JIT_pow_i1_r:
    result = op->result; DCheckBinop_x1_y(INTSXP, REALSXP, result);
    ar = REAL(result); xi0 = XI[0]; yr = YR; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xi0, yr[i]);   stack[--istack] = result;
    break;

case JIT_pow_i1_r1:
    result = op->result; DCheckBinop_x1_y1(INTSXP, REALSXP, result);
    REAL(result)[0] = pow(XI[0], YR[0]);               stack[--istack] = result;
    break;

// begin unsual code: return REAL even though args are INTs, same as arithmetic.c
case JIT_pow_i_i:
    result = op->result; DCheckBinop_x_y(INTSXP, INTSXP, result);
    ar = REAL(result); xi = XI; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xi[i], yi[i]); stack[--istack] = result;
    break;

case JIT_pow_i_i1:
    result = op->result; DCheckBinop_x_y1(INTSXP, INTSXP, result);
    ar = REAL(result); xi = XI; yi0 = YI[0]; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xi[i], yi0);   stack[--istack] = result;
    break;

case JIT_pow_i1_i:
    result = op->result; DCheckBinop_x1_y(INTSXP, INTSXP, result);
    ar = REAL(result); xi0 = XI[0]; yi = YI; n = LENGTH(result);
    for (i = 0; i < n; i++) ar[i] = pow(xi0, yi[i]);   stack[--istack] = result;
    break;

case JIT_pow_i1_i1:
    result = op->result; DCheckBinop_x1_y1(INTSXP, INTSXP, result);
    REAL(result)[0] = pow(XI[0], YI[0]);               stack[--istack] = result;
    break;
// end unusual code

default:
    error("internal assertion failed: bad JIT opcode 0x%x %s\n"
          "Please save your data and quit the R session.",
          op->opcode, jitOpcodeName(op->opcode));
    break;
